## scalapack 2.2.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.2)

project(SCALAPACK VERSION 2.2.1 LANGUAGES C Fortran)

# Configure the warning and code coverage suppression file
configure_file(
  "${SCALAPACK_SOURCE_DIR}/CMAKE/CTestCustom.cmake.in"
  "${SCALAPACK_BINARY_DIR}/CTestCustom.cmake"
  COPYONLY
)

# Add the CMake directory for custon CMake modules
set(CMAKE_MODULE_PATH "${SCALAPACK_SOURCE_DIR}/CMAKE" ${CMAKE_MODULE_PATH})

if (UNIX)
   if ("${CMAKE_Fortran_COMPILER_ID}" STREQUAL "Intel")
      set( CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -fltconsistency -fp_port" )
   endif ()
endif ()

#
#   MPI
#
#set(MPI_BASE_DIR "/Users/julie/opt/openmpi/" CACHE PATH "MPI Path")
#set(MPI_BASE_DIR "/Users/julie/opt/mpich2/" CACHE PATH "MPI Path")
set(CMAKE_PREFIX_PATH "${MPI_BASE_DIR};${CMAKE_PREFIX_PATH}")
#set(MPI_COMPILER ${MPI_BASE_DIR}/bin/mpicc)

find_package(MPI)
if (MPI_FOUND)
   message(STATUS "Found MPI_LIBRARY : ${MPI_FOUND} ")
   INCLUDE_DIRECTORIES(${MPI_INCLUDE_PATH})

   find_program(MPI_C_COMPILER
      NAMES mpicc
      HINTS "${MPI_BASE_DIR}"
      PATH_SUFFIXES bin
      DOC "MPI C compiler.")
   MARK_AS_ADVANCED(MPI_C_COMPILER)
   if ("${MPI_C_COMPILER}" STREQUAL "MPI_C_COMPILER-NOTFOUND")
      message(ERROR "--> MPI C Compiler NOT FOUND (please set MPI_BASE_DIR accordingly")
   else()
      message(STATUS "--> MPI C Compiler : ${MPI_C_COMPILER}")
      SET(CMAKE_C_COMPILER "${MPI_C_COMPILER}")
      message(STATUS "--> C Compiler : ${CMAKE_C_COMPILER}")
   endif()
   find_program(MPI_Fortran_COMPILER
      NAMES mpif77
      HINTS "${MPI_BASE_DIR}"
      PATH_SUFFIXES bin
      DOC "MPI Fortran compiler.")
   MARK_AS_ADVANCED(MPI_Fortran_COMPILER)



   if ("${MPI_Fortran_COMPILER}" STREQUAL "MPI_Fortran_COMPILER-NOTFOUND")
      message(ERROR "--> MPI Fortran Compiler NOT FOUND (please set MPI_BASE_DIR accordingly")
   else()
      message(STATUS "--> MPI Fortran Compiler : ${MPI_Fortran_COMPILER}")
      SET(Fortran_COMPILER "${CMAKE_Fortran_COMPILER}")
      #SET(CMAKE_Fortran_COMPILER "${MPI_Fortran_COMPILER}")
      message(STATUS "--> Fortran Compiler : ${CMAKE_Fortran_COMPILER}")
   endif()

else()
   message(STATUS "Found MPI_LIBRARY : ${MPI_FOUND} ")
   set(MPI_BASE_DIR ${MPI_BASE_DIR} CACHE PATH "MPI Path")
   UNSET(MPIEXEC CACHE)
   UNSET(MPIEXEC_POSTFLAGS CACHE)
   UNSET(MPIEXEC_PREFLAGS CACHE)
   UNSET(MPIEXEC_MAX_NUMPROCS CACHE)
   UNSET(MPIEXEC_NUMPROC_FLAG CACHE)
   UNSET(MPI_COMPILE_FLAGS CACHE)
   UNSET(MPI_LINK_FLAGS CACHE)
   UNSET(MPI_INCLUDE_PATH CACHE)
   message(FATAL_ERROR "--> MPI Library NOT FOUND -- please set MPI_BASE_DIR accordingly --")
endif()


if (UNIX)
   if ("${CMAKE_Fortran_COMPILER_ID}" STREQUAL "Intel")
      set( CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -fltconsistency -fp_port" )
   endif ()
endif ()

macro(SCALAPACK_install_library lib)
  install(TARGETS ${lib} EXPORT scalapack-targets
    ARCHIVE DESTINATION lib${LIB_SUFFIX}
    LIBRARY DESTINATION lib${LIB_SUFFIX}
    RUNTIME DESTINATION Testing
  )
endmacro()

# --------------------------------------------------
# Testing
SET(DART_TESTING_TIMEOUT 600)

enable_testing()
include(CTest)
enable_testing()
# --------------------------------------------------

# Organize output files.  On Windows this also keeps .dll files next
# to the .exe files that need them, making tests easy to run.
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${SCALAPACK_BINARY_DIR}/TESTING)
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${SCALAPACK_BINARY_DIR}/lib)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${SCALAPACK_BINARY_DIR}/lib)

# --------------------------------------------------
# Check for any necessary platform specific compiler flags
include( CheckBLACSCompilerFlags )
CheckBLACSCompilerFlags()

set(prefix ${CMAKE_INSTALL_PREFIX})
set(libdir ${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX})
set(PKG_CONFIG_DIR ${libdir}/pkgconfig)

# --------------------------------------------------
# BLACS Internal variables
#
#   Fortran Mangling, MPI Tests and BLACS settings
#
include(FortranMangling)
COMPILE(install_COMPILED)

FORTRAN_MANGLING(CDEFS)
#MESSAGE(STATUS "Setting CDEFS = ${CDEFS}")
#set(CDEFS ${CDEFS} CACHE STRING "Fortran Mangling" FORCE)
MESSAGE(STATUS "=========")

# --------------------------------------------------
# Compiler Flags
ADD_DEFINITIONS( "-D${CDEFS}")

# --------------------------------------------------
# ScaLAPACK needs BLAS and LAPACK

option(USE_OPTIMIZED_LAPACK_BLAS "Whether or not to search for optimized LAPACK and BLAS libraries on your machine (if not found, Reference LAPACK and BLAS will be downloaded and installed)" ON)

message(STATUS "CHECKING BLAS AND LAPACK LIBRARIES")

IF(LAPACK_LIBRARIES)
  include(CheckFortranFunctionExists)
  message(STATUS "--> LAPACK supplied by user is ${LAPACK_LIBRARIES}.")
  set(CMAKE_REQUIRED_LIBRARIES ${LAPACK_LIBRARIES})
  CHECK_FORTRAN_FUNCTION_EXISTS("dgesv" LAPACK_FOUND)
  unset( CMAKE_REQUIRED_LIBRARIES )
  message(STATUS "--> LAPACK routine dgesv is found: ${LAPACK_FOUND}.")
ENDIF()

if(LAPACK_FOUND)
      message(STATUS "--> LAPACK supplied by user is WORKING, will use ${LAPACK_LIBRARIES}.")
else(LAPACK_FOUND)
   if(USE_OPTIMIZED_LAPACK_BLAS)
      message(STATUS "--> Searching for optimized LAPACK and BLAS libraries on your machine.")
      find_package(LAPACK)
   ENDIF(USE_OPTIMIZED_LAPACK_BLAS)
   if(NOT LAPACK_FOUND)
      message(STATUS "--> LAPACK and BLAS were not found. Reference LAPACK and BLAS will be downloaded and installed")
      include(ExternalProject)
      ExternalProject_Add(
		lapack
		URL http://www.netlib.org/lapack/lapack.tgz
		CMAKE_ARGS -DCMAKE_INSTALL_PREFIX:PATH=${SCALAPACK_BINARY_DIR}
        PREFIX ${SCALAPACK_BINARY_DIR}/dependencies
      )
	  if (UNIX)
         SET(LAPACK_LIBRARIES ${SCALAPACK_BINARY_DIR}/lib/liblapack.a CACHE STRING "LAPACK library" FORCE)
         SET(BLAS_LIBRARIES ${SCALAPACK_BINARY_DIR}/lib/libblas.a CACHE STRING "BLAS library" FORCE)
	  else (UNIX) # On Windows
         SET(LAPACK_LIBRARIES ${SCALAPACK_BINARY_DIR}/lib/liblapack.lib CACHE STRING "LAPACK library" FORCE)
         SET(BLAS_LIBRARIES ${SCALAPACK_BINARY_DIR}/lib/libblas.lib CACHE STRING "BLAS library" FORCE)
      endif (UNIX)
   ENDIF()
ENDIF()

message(STATUS "BLAS library: ${BLAS_LIBRARIES}")
message(STATUS "LAPACK library: ${LAPACK_LIBRARIES}")

MESSAGE(STATUS "=========")

# --------------------------------------------------
# By default static library
OPTION(BUILD_SHARED_LIBS "Build shared libraries" OFF )
OPTION(BUILD_STATIC_LIBS "Build static libraries" ON )

# --------------------------------------------------
# Subdirectories that need to be processed

macro(append_subdir_files variable dirname)
get_directory_property(holder DIRECTORY ${dirname} DEFINITION ${variable})
foreach(depfile ${holder})
  list(APPEND ${variable} "${dirname}/${depfile}")
endforeach()
endmacro()


#
# BLACS
#
add_subdirectory(BLACS)
append_subdir_files(blacs "BLACS/SRC")

#
# TOOLS
#
add_subdirectory(TOOLS)
append_subdir_files(tools TOOLS)
append_subdir_files(tools-C TOOLS)
append_subdir_files(extra_lapack "TOOLS/LAPACK")

#
# PBLAS
#
add_subdirectory(PBLAS)
append_subdir_files(pblas "PBLAS/SRC")
append_subdir_files(pblas-F "PBLAS/SRC")
append_subdir_files(pbblas "PBLAS/SRC/PBBLAS")
append_subdir_files(ptzblas "PBLAS/SRC/PTZBLAS")
append_subdir_files(ptools "PBLAS/SRC/PTOOLS")

#
# REDIST
#
add_subdirectory(REDIST)
append_subdir_files(redist "REDIST/SRC")

#
# SRC
#
add_subdirectory(SRC)
append_subdir_files(src "SRC")
append_subdir_files(src-C "SRC")

if (UNIX)
   add_library(scalapack ${blacs} ${tools} ${tools-C} ${extra_lapack} ${pblas} ${pblas-F} ${ptzblas} ${ptools} ${pbblas} ${redist} ${src} ${src-C})
   set_target_properties(scalapack PROPERTIES
    VERSION ${SCALAPACK_VERSION}
    SOVERSION ${SCALAPACK_VERSION_MAJOR}.${SCALAPACK_VERSION_MINOR})
   target_link_libraries( scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})
   scalapack_install_library(scalapack)
else (UNIX) # Need to separate Fortran and C Code
   OPTION(BUILD_SHARED_LIBS "Build shared libraries" ON )
   add_library(scalapack ${blacs} ${tools-C} ${pblas} ${ptools} ${redist} ${src-C})
   set_target_properties(scalapack PROPERTIES
    VERSION ${SCALAPACK_VERSION}
    SOVERSION ${SCALAPACK_VERSION_MAJOR}.${SCALAPACK_VERSION_MINOR})
   target_link_libraries( scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})
   add_library(scalapack-F ${pblas-F} ${pbblas} ${ptzblas} ${tools} ${src} ${extra_lapack} )
   set_target_properties(scalapack-F PROPERTIES
    VERSION ${SCALAPACK_VERSION}
    SOVERSION ${SCALAPACK_VERSION_MAJOR}.${SCALAPACK_VERSION_MINOR})
   target_link_libraries( scalapack-F ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})
   scalapack_install_library(scalapack)
   scalapack_install_library(scalapack-F)
endif (UNIX)

option(SCALAPACK_BUILD_TESTS "Build all tests of the ScaLAPACK library" ON)
if(${SCALAPACK_BUILD_TESTS})
  add_subdirectory(TESTING)
endif()

# --------------------------------------------------
# CPACK Packaging

SET(CPACK_PACKAGE_NAME "ScaLAPACK")
SET(CPACK_PACKAGE_VENDOR "University of Tennessee, Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd")
SET(CPACK_PACKAGE_DESCRIPTION_SUMMARY "ScaLAPACK- Linear Algebra Package")
set(CPACK_PACKAGE_VERSION_MAJOR ${SCALAPACK_VERSION_MAJOR})
set(CPACK_PACKAGE_VERSION_MINOR ${SCALAPACK_VERSION_MINOR})
set(CPACK_PACKAGE_VERSION_PATCH ${SCALAPACK_VERSION_PATCH})
set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/LICENSE")
SET(CPACK_PACKAGE_INSTALL_DIRECTORY "SCALAPACK")
IF(WIN32 AND NOT UNIX)
  # There is a bug in NSI that does not handle full unix paths properly. Make
  # sure there is at least one set of four (4) backlasshes.
  SET(CPACK_NSIS_HELP_LINK "http:\\\\\\\\http://icl.cs.utk.edu/lapack-forum")
  SET(CPACK_NSIS_URL_INFO_ABOUT "http:\\\\\\\\www.netlib.org/scalapack")
  SET(CPACK_NSIS_CONTACT "scalapack@eecs.utk.edu")
  SET(CPACK_NSIS_MODIFY_PATH ON)
  SET(CPACK_NSIS_DISPLAY_NAME "SCALAPACK-${SCALAPACK_VERSION}")
  set(CPACK_PACKAGE_RELOCATABLE "true")
ELSE(WIN32 AND NOT UNIX)
  SET(CPACK_GENERATOR "TGZ")
  SET(CPACK_SOURCE_GENERATOR TGZ)
  SET(CPACK_SOURCE_PACKAGE_FILE_NAME "scalapack-${SCALAPACK_VERSION}" )
  SET(CPACK_SOURCE_IGNORE_FILES ~$ .svn ${CPACK_SOURCE_IGNORE_FILES} )
ENDIF(WIN32 AND NOT UNIX)
INCLUDE(CPack)


# --------------------------------------------------


export(TARGETS scalapack FILE scalapack-targets.cmake)

if( NOT LAPACK_FOUND )
 install(FILES
  ${BLAS_LIBRARIES} ${LAPACK_LIBRARIES}
  DESTINATION lib
   )
endif( NOT LAPACK_FOUND )

configure_file(${SCALAPACK_SOURCE_DIR}/CMAKE/scalapack-config-version.cmake.in
  ${SCALAPACK_BINARY_DIR}/scalapack-config-version.cmake @ONLY)
configure_file(${SCALAPACK_SOURCE_DIR}/CMAKE/scalapack-config-build.cmake.in
  ${SCALAPACK_BINARY_DIR}/scalapack-config.cmake @ONLY)

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/scalapack.pc.in ${CMAKE_CURRENT_BINARY_DIR}/scalapack.pc)
 install(FILES
  ${CMAKE_CURRENT_BINARY_DIR}/scalapack.pc
  DESTINATION ${PKG_CONFIG_DIR}
   )

configure_file(${SCALAPACK_SOURCE_DIR}/CMAKE/scalapack-config-install.cmake.in
  ${SCALAPACK_BINARY_DIR}/CMakeFiles/scalapack-config.cmake @ONLY)
install(FILES
  ${SCALAPACK_BINARY_DIR}/CMakeFiles/scalapack-config.cmake
  ${SCALAPACK_BINARY_DIR}/scalapack-config-version.cmake
  DESTINATION lib/cmake/scalapack-${SCALAPACK_VERSION}
  )

install(EXPORT scalapack-targets
  DESTINATION lib/cmake/scalapack-${SCALAPACK_VERSION})

=== BLACS/CMakeLists.txt ===
add_subdirectory(SRC)
if(${SCALAPACK_BUILD_TESTING})
  add_subdirectory(TESTING)
endif()

=== PBLAS/CMakeLists.txt ===
add_subdirectory(SRC)
if(${SCALAPACK_BUILD_TESTING})
  add_subdirectory(TESTING)
  add_subdirectory(TIMING)
endif()

=== BLACS/INSTALL/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)
project(INSTALL C Fortran)

add_executable(xintface Fintface.f Cintface.c)

=== BLACS/SRC/Makefile ===
dlvl = ../..
include $(dlvl)/SLmake.inc

#  --------------------------
#  The communication routines
#  --------------------------
comm = igesd2d_.o sgesd2d_.o dgesd2d_.o cgesd2d_.o zgesd2d_.o \
       itrsd2d_.o strsd2d_.o dtrsd2d_.o ctrsd2d_.o ztrsd2d_.o \
       igerv2d_.o sgerv2d_.o dgerv2d_.o cgerv2d_.o zgerv2d_.o \
       itrrv2d_.o strrv2d_.o dtrrv2d_.o ctrrv2d_.o ztrrv2d_.o \
       igebs2d_.o sgebs2d_.o dgebs2d_.o cgebs2d_.o zgebs2d_.o \
       igebr2d_.o sgebr2d_.o dgebr2d_.o cgebr2d_.o zgebr2d_.o \
       itrbs2d_.o strbs2d_.o dtrbs2d_.o ctrbs2d_.o ztrbs2d_.o \
       itrbr2d_.o strbr2d_.o dtrbr2d_.o ctrbr2d_.o ztrbr2d_.o \
       igsum2d_.o sgsum2d_.o dgsum2d_.o cgsum2d_.o zgsum2d_.o \
       igamx2d_.o sgamx2d_.o dgamx2d_.o cgamx2d_.o zgamx2d_.o \
       igamn2d_.o sgamn2d_.o dgamn2d_.o cgamn2d_.o zgamn2d_.o

#  --------------------
#  The support routines
#  --------------------
supp = blacs_setup_.o blacs_set_.o blacs_get_.o \
       blacs_abort_.o blacs_exit_.o blacs_pnum_.o blacs_pcoord_.o \
       ksendid_.o krecvid_.o kbsid_.o kbrid_.o \
       dcputime00_.o dwalltime00_.o blacs_pinfo_.o \
       blacs_init_.o blacs_map_.o blacs_free_.o blacs_grid_.o blacs_info_.o \
       blacs_barr_.o sys2blacs_.o blacs2sys_.o free_handle_.o


#  ----------------------------
#  The fortran and C interfaces
#  ----------------------------
Fintobj   = $(comm) $(supp)
Cintobj   = $(comm:.o=.oo) $(supp:.o=.oo)

#  ---------------------
#  The internal routines
#  ---------------------
internal = BI_HypBS.o BI_HypBR.o BI_IdringBS.o BI_IdringBR.o \
           BI_MpathBS.o BI_MpathBR.o BI_SringBS.o BI_SringBR.o \
           BI_TreeBS.o BI_TreeBR.o \
           BI_Ssend.o BI_Rsend.o BI_Srecv.o BI_Asend.o BI_Arecv.o \
           BI_TreeComb.o BI_BeComb.o BI_MringComb.o \
           BI_ArgCheck.o BI_TransDist.o BI_GetBuff.o BI_UpdateBuffs.o \
           BI_EmergencyBuff.o BI_BlacsErr.o BI_BlacsWarn.o BI_BlacsAbort.o \
           BI_BuffIsFree.o BI_imvcopy.o BI_smvcopy.o BI_dmvcopy.o \
           BI_ivmcopy.o BI_svmcopy.o BI_dvmcopy.o \
           BI_Pack.o BI_Unpack.o BI_GetMpiGeType.o BI_GetMpiTrType.o \
           BI_ivvsum.o BI_svvsum.o BI_dvvsum.o BI_cvvsum.o BI_zvvsum.o \
           BI_ivvamx.o BI_svvamx.o BI_dvvamx.o BI_cvvamx.o BI_zvvamx.o \
           BI_ivvamx2.o BI_svvamx2.o BI_dvvamx2.o BI_cvvamx2.o BI_zvvamx2.o \
           BI_ivvamn.o BI_svvamn.o BI_dvvamn.o BI_cvvamn.o BI_zvvamn.o \
           BI_ivvamn2.o BI_svvamn2.o BI_dvvamn2.o BI_cvvamn2.o BI_zvvamn2.o \
           BI_iMPI_amx.o BI_sMPI_amx.o BI_dMPI_amx.o BI_cMPI_amx.o \
           BI_zMPI_amx.o BI_iMPI_amx2.o BI_sMPI_amx2.o BI_dMPI_amx2.o \
           BI_cMPI_amx2.o BI_zMPI_amx2.o BI_iMPI_amn.o BI_sMPI_amn.o \
           BI_dMPI_amn.o BI_cMPI_amn.o BI_zMPI_amn.o BI_iMPI_amn2.o \
           BI_sMPI_amn2.o BI_dMPI_amn2.o BI_cMPI_amn2.o BI_zMPI_amn2.o \
           BI_cMPI_sum.o BI_zMPI_sum.o BI_ContxtNum.o BI_GlobalVars.o \
           BI_TransUserComm.o

lib : all

$(internal): Bdef.h Bconfig.h

$(Fintobj): Bdef.h Bconfig.h

#  ---------------------------------------
#  Make both C and fortran interface BLACS
#  ---------------------------------------
all : $(internal) $(Fintobj) $(Cintobj)
	$(ARCH) $(ARCHFLAGS) ../../$(SCALAPACKLIB) $(internal) $(Fintobj) $(Cintobj)
	$(RANLIB) ../../$(SCALAPACKLIB)

#  -----------------------
#  Delete the object files
#  -----------------------
clean :
	rm -f $(Cintobj) $(Fintobj) $(internal)

#  ------------------------------------------------------------------------
#  We move C .o files to .oo so that we can use the portable suffix rule for
#  compilation, and still have them coexist with the fortran interface
#  .o files.
#  ------------------------------------------------------------------------

.SUFFIXES: .o .oo
.c.oo:
	$(CC) -o C$*.o -c $(CDEFS) $(CCFLAGS) -DCallFromC $<
	mv C$*.o $*.oo
.c.o:
	$(CC) -c $(CDEFS) $(CCFLAGS) $<

=== BLACS/TESTING/CMakeLists.txt ===
set(FTestObj
   blacstest.f btprim.f tools.f)

if ("${CMAKE_Fortran_COMPILER_ID}" STREQUAL "GNU" AND CMAKE_Fortran_COMPILER_VERSION VERSION_GREATER_EQUAL 10)
    set_source_files_properties(blacstest.f PROPERTIES COMPILE_FLAGS "-std=legacy")
endif()

add_executable(xFbtest ${FTestObj})
target_link_libraries(xFbtest scalapack)

set(CTestObj
   Cbt.c)

set_property(
   SOURCE Cbt.c
   APPEND PROPERTY COMPILE_DEFINITIONS BTCINTFACE
   )

add_executable(xCbtest ${CTestObj} ${FTestObj})
target_link_libraries(xCbtest scalapack)

file(COPY bsbr.dat DESTINATION ${SCALAPACK_BINARY_DIR}/BLACS/TESTING)
file(COPY bt.dat DESTINATION ${SCALAPACK_BINARY_DIR}/BLACS/TESTING)
file(COPY comb.dat DESTINATION ${SCALAPACK_BINARY_DIR}/BLACS/TESTING)
file(COPY sdrv.dat DESTINATION ${SCALAPACK_BINARY_DIR}/BLACS/TESTING)

# We could run the BLACS TESTING the following way
# But BLACS TESTING are TESTING anormal exit so even if they pass,
# CTest will determine they fail
#add_test(xFbtest0 ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 ./xFbtest)
#add_test(xCbtest0 ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 ./xCbtest)

add_test(xCbtest
     ${CMAKE_COMMAND}
    -DMPIEXEC=${MPIEXEC}
    -DMPIEXEC_NUMPROC_FLAG=${MPIEXEC_NUMPROC_FLAG}
    -DTEST_PROG=xCbtest
    -DOUTPUTDIR=${SCALAPACK_BINARY_DIR}/BLACS/TESTING
    -DRUNTIMEDIR=${CMAKE_RUNTIME_OUTPUT_DIRECTORY}
    -DSOURCEDIR=${CMAKE_CURRENT_SOURCE_DIR}
    -P ${CMAKE_CURRENT_SOURCE_DIR}/runtest.cmake
    )

add_test(xFbtest
     ${CMAKE_COMMAND}
    -DMPIEXEC=${MPIEXEC}
    -DMPIEXEC_NUMPROC_FLAG=${MPIEXEC_NUMPROC_FLAG}
    -DTEST_PROG=xFbtest
    -DOUTPUTDIR=${SCALAPACK_BINARY_DIR}/BLACS/TESTING
    -DRUNTIMEDIR=${CMAKE_RUNTIME_OUTPUT_DIRECTORY}
    -DSOURCEDIR=${CMAKE_CURRENT_SOURCE_DIR}
    -P ${CMAKE_CURRENT_SOURCE_DIR}/runtest.cmake
    )

=== PBLAS/SRC/CMakeLists.txt ===
add_subdirectory(PBBLAS)
add_subdirectory(PTZBLAS)
add_subdirectory(PTOOLS)

set (APPBLAS  pilaenv.f)

#---------------------------------------------------------------------------
#  Level 1 PBLAS.
#---------------------------------------------------------------------------

set (PIBLAS1  picopy_.c)

set (PSBLAS1  psswap_.c psscal_.c  pscopy_.c  psaxpy_.c psdot_.c  psnrm2_.c 
          psasum_.c psamax_.c)

set (PCBLAS1  pcswap_.c pcscal_.c  pcsscal_.c pccopy_.c pcaxpy_.c pcdotu_.c 
          pcdotc_.c pscnrm2_.c pscasum_.c pcamax_.c)

set (PDBLAS1  pdswap_.c pdscal_.c  pdcopy_.c  pdaxpy_.c pddot_.c  pdnrm2_.c 
          pdasum_.c pdamax_.c)

set (PZBLAS1  pzswap_.c pzscal_.c  pzdscal_.c pzcopy_.c pzaxpy_.c pzdotu_.c 
          pzdotc_.c pdznrm2_.c pdzasum_.c pzamax_.c)

#---------------------------------------------------------------------------
#  Level 2 PBLAS.
#---------------------------------------------------------------------------

set (PSBLAS2  psgemv_.c  psger_.c   pssymv_.c  pssyr_.c   pssyr2_.c  pstrmv_.c 
          pstrsv_.c  psagemv_.c psasymv_.c psatrmv_.c)

set (PCBLAS2  pcgemv_.c  pcgerc_.c  pcgeru_.c  pchemv_.c  pcher_.c   pcher2_.c 
          pctrmv_.c  pctrsv_.c  pcagemv_.c pcahemv_.c pcatrmv_.c)

set (PDBLAS2  pdgemv_.c  pdger_.c   pdsymv_.c  pdsyr_.c   pdsyr2_.c  pdtrmv_.c 
          pdtrsv_.c  pdagemv_.c pdasymv_.c pdatrmv_.c)

set (PZBLAS2  pzgemv_.c  pzgerc_.c  pzgeru_.c  pzhemv_.c  pzher_.c   pzher2_.c 
          pztrmv_.c  pztrsv_.c  pzagemv_.c pzahemv_.c pzatrmv_.c)

#---------------------------------------------------------------------------
#  Level 3 PBLAS.
#---------------------------------------------------------------------------

set (PSBLAS3  psgeadd_.c psgemm_.c pssymm_.c  pssyr2k_.c pssyrk_.c  pstradd_.c 
          pstran_.c  pstrmm_.c pstrsm_.c)

set (PCBLAS3  pcgeadd_.c pcgemm_.c pchemm_.c  pcher2k_.c pcherk_.c  pcsymm_.c  
          pcsyr2k_.c pcsyrk_.c pctradd_.c pctranc_.c pctranu_.c pctrmm_.c  
          pctrsm_.c)

set (PDBLAS3  pdgeadd_.c pdgemm_.c pdsymm_.c  pdsyr2k_.c pdsyrk_.c  pdtradd_.c 
          pdtran_.c  pdtrmm_.c pdtrsm_.c)

set (PZBLAS3  pzgeadd_.c pzgemm_.c pzhemm_.c  pzher2k_.c pzherk_.c  pzsymm_.c  
          pzsyr2k_.c pzsyrk_.c pztradd_.c pztranc_.c pztranu_.c pztrmm_.c  
          pztrsm_.c)

#---------------------------------------------------------------------------

set (pblas 
      ${PIBLAS1}
      ${PSBLAS1} ${PCBLAS1} ${PDBLAS1} ${PZBLAS1}
      ${PSBLAS2} ${PCBLAS2} ${PDBLAS2} ${PZBLAS2}
      ${PSBLAS3} ${PCBLAS3} ${PDBLAS3} ${PZBLAS3})

set (pblas-F ${APPBLAS} )

=== PBLAS/TESTING/CMakeLists.txt ===
file(COPY ../SRC/PTOOLS/PB_Cwarn.c DESTINATION ${CMAKE_CURRENT_SOURCE_DIR})
file(COPY ../SRC/PTOOLS/PB_Cabort.c DESTINATION ${CMAKE_CURRENT_SOURCE_DIR})

set (PblasErrorHandler  PB_Cwarn.c PB_Cabort.c)
set (pbtcom pblastst.f ${PblasErrorHandler})
set (spbtcom psblastst.f slamch.f ${pbtcom})
set (dpbtcom pdblastst.f dlamch.f ${pbtcom})
set (cpbtcom pcblastst.f slamch.f ${pbtcom})
set (zpbtcom pzblastst.f dlamch.f ${pbtcom})

set_property(
   SOURCE ${PblasErrorHandler}
   APPEND PROPERTY COMPILE_DEFINITIONS TestingPblas
   )

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${SCALAPACK_BINARY_DIR}/PBLAS/TESTING)

file(COPY PCBLAS1TST.dat DESTINATION ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})
file(COPY PCBLAS2TST.dat DESTINATION ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})
file(COPY PCBLAS3TST.dat DESTINATION ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})
file(COPY PDBLAS1TST.dat DESTINATION ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})
file(COPY PDBLAS2TST.dat DESTINATION ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})
file(COPY PDBLAS3TST.dat DESTINATION ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})
file(COPY PSBLAS1TST.dat DESTINATION ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})
file(COPY PSBLAS2TST.dat DESTINATION ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})
file(COPY PSBLAS3TST.dat DESTINATION ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})
file(COPY PZBLAS1TST.dat DESTINATION ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})
file(COPY PZBLAS2TST.dat DESTINATION ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})
file(COPY PZBLAS3TST.dat DESTINATION ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})


add_executable(spb1tst psblas1tst.f ${spbtcom})
add_executable(dpb1tst pdblas1tst.f ${dpbtcom})
add_executable(cpb1tst pcblas1tst.f ${cpbtcom})
add_executable(zpb1tst pzblas1tst.f ${zpbtcom})

add_executable(spb2tst psblas2tst.f ${spbtcom})
add_executable(dpb2tst pdblas2tst.f ${dpbtcom})
add_executable(cpb2tst pcblas2tst.f ${cpbtcom})
add_executable(zpb2tst pzblas2tst.f ${zpbtcom})

add_executable(spb3tst psblas3tst.f ${spbtcom})
add_executable(dpb3tst pdblas3tst.f ${dpbtcom})
add_executable(cpb3tst pcblas3tst.f ${cpbtcom})
add_executable(zpb3tst pzblas3tst.f ${zpbtcom})

target_link_libraries(spb1tst scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})
target_link_libraries(dpb1tst scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})
target_link_libraries(cpb1tst scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})
target_link_libraries(zpb1tst scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})

target_link_libraries(spb2tst scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})
target_link_libraries(dpb2tst scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})
target_link_libraries(cpb2tst scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})
target_link_libraries(zpb2tst scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})

target_link_libraries(spb3tst scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})
target_link_libraries(dpb3tst scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})
target_link_libraries(cpb3tst scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})
target_link_libraries(zpb3tst scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})

add_test(spb1tst ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 ./spb1tst)
add_test(dpb1tst ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 ./dpb1tst)
add_test(cpb1tst ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 ./cpb1tst)
add_test(zpb1tst ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 ./zpb1tst)

add_test(spb2tst ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 ./spb2tst)
add_test(dpb2tst ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 ./dpb2tst)
add_test(cpb2tst ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 ./cpb2tst)
add_test(zpb2tst ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 ./zpb2tst)

add_test(spb3tst ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 ./spb3tst)
add_test(dpb3tst ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 ./dpb3tst)
add_test(cpb3tst ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 ./cpb3tst)
add_test(zpb3tst ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} 4 ./zpb3tst)

if ("${CMAKE_Fortran_COMPILER_ID}" STREQUAL "GNU" AND CMAKE_Fortran_COMPILER_VERSION VERSION_GREATER_EQUAL 10)
    set( CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -std=legacy" )  # local to this directory
endif()

=== REDIST/SRC/CMakeLists.txt ===
set (ALLAUX  
   pgemraux.c)

set (IMRSRC  
   pigemr.c pigemr2.c pitrmr.c pitrmr2.c)

set (SMRSRC  
   psgemr.c psgemr2.c pstrmr.c pstrmr2.c)

set (CMRSRC  
   pcgemr.c pcgemr2.c pctrmr.c pctrmr2.c)

set (DMRSRC  
   pdgemr.c pdgemr2.c pdtrmr.c pdtrmr2.c)

set (ZMRSRC  
   pzgemr.c pzgemr2.c pztrmr.c pztrmr2.c)
   
set(redist ${ALLAUX} ${IMRSRC} ${SMRSRC} ${CMRSRC} ${DMRSRC} ${ZMRSRC})

=== TESTING/EIG/CMakeLists.txt ===
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${SCALAPACK_BINARY_DIR}/TESTING)

set (smatgen psmatgen.f pmatgeninc.f)
set (dmatgen pdmatgen.f pmatgeninc.f)
set (cmatgen pcmatgen.f pmatgeninc.f)
set (zmatgen pzmatgen.f pmatgeninc.f)

add_executable(xsbrd psbrddriver.f psbrdinfo.f psgebdrv.f pslafchk.f ${smatgen})
add_executable(xdbrd pdbrddriver.f pdbrdinfo.f pdgebdrv.f pdlafchk.f ${dmatgen})
add_executable(xcbrd pcbrddriver.f pcbrdinfo.f pcgebdrv.f pclafchk.f ${cmatgen})
add_executable(xzbrd pzbrddriver.f pzbrdinfo.f pzgebdrv.f pzlafchk.f ${zmatgen})

add_executable(xshrd pshrddriver.f pshrdinfo.f psgehdrv.f pslafchk.f ${smatgen})
add_executable(xdhrd pdhrddriver.f pdhrdinfo.f pdgehdrv.f pdlafchk.f ${dmatgen})
add_executable(xchrd pchrddriver.f pchrdinfo.f pcgehdrv.f pclafchk.f ${cmatgen})
add_executable(xzhrd pzhrddriver.f pzhrdinfo.f pzgehdrv.f pzlafchk.f ${zmatgen})

add_executable(xstrd pstrddriver.f psttrdtester.f pslatran.f pstrdinfo.f pssytdrv.f pslafchk.f xpjlaenv.f ${smatgen})
add_executable(xdtrd pdtrddriver.f pdttrdtester.f pdlatran.f pdtrdinfo.f pdsytdrv.f pdlafchk.f xpjlaenv.f ${dmatgen})
add_executable(xctrd pctrddriver.f pcttrdtester.f pclatran.f pctrdinfo.f pchetdrv.f pclafchk.f xpjlaenv.f ${cmatgen})
add_executable(xztrd pztrddriver.f pzttrdtester.f pzlatran.f pztrdinfo.f pzhetdrv.f pzlafchk.f xpjlaenv.f ${zmatgen})

add_executable(xssvd pssvddriver.f pslagge.f pssvdchk.f pssvdcmp.f pssvdtst.f ${smatgen})
add_executable(xdsvd pdsvddriver.f pdlagge.f pdsvdchk.f pdsvdcmp.f pdsvdtst.f ${dmatgen})

add_executable(xssep psseptst.f pssepsubtst.f pssepchk.f pssepqtq.f pslagsy.f pslatms.f pslasizesep.f pslasizesyevx.f pssepdriver.f pssepreq.f pssepinfo.f pslasizesyev.f pssqpsubtst.f pslasizesqp.f pssdpsubtst.f ${smatgen})
add_executable(xdsep pdseptst.f pdsepsubtst.f pdsepchk.f pdsepqtq.f pdlagsy.f pdlatms.f pdlasizesep.f pdlasizesyevx.f pdsepdriver.f pdsepreq.f pdsepinfo.f pdlasizesyev.f pdsqpsubtst.f pdlasizesqp.f pdsdpsubtst.f ${dmatgen})
add_executable(xcsep pcseptst.f pcsepsubtst.f pcsepchk.f pcsepqtq.f pclagsy.f pclatms.f pclasizesep.f pclasizeheevx.f pcsepdriver.f pcsepreq.f pssepinfo.f pcsdpsubtst.f ${cmatgen})
add_executable(xzsep pzseptst.f pzsepsubtst.f pzsepchk.f pzsepqtq.f pzlagsy.f pzlatms.f pzlasizesep.f pzlasizeheevx.f pzsepdriver.f pzsepreq.f pdsepinfo.f pzsdpsubtst.f ${zmatgen})

add_executable(xsgsep psgseptst.f psgsepsubtst.f psgsepchk.f pslagsy.f pslatms.f pslasizesyevx.f pslasizegsep.f pslasizesep.f psgsepdriver.f psgsepreq.f pssepinfo.f ${smatgen})
add_executable(xdgsep pdgseptst.f pdgsepsubtst.f pdgsepchk.f pdlagsy.f pdlatms.f pdlasizesyevx.f pdlasizegsep.f pdlasizesep.f pdgsepdriver.f pdgsepreq.f pdsepinfo.f ${dmatgen})
add_executable(xcgsep pcgseptst.f pcgsepsubtst.f pcgsepchk.f pclagsy.f pclatms.f pclasizegsep.f pclasizeheevx.f pclasizesep.f pcgsepdriver.f pcgsepreq.f pssepinfo.f ${cmatgen})
add_executable(xzgsep pzgseptst.f pzgsepsubtst.f pzgsepchk.f pzlagsy.f pzlatms.f pzlasizegsep.f pzlasizeheevx.f pzlasizesep.f pzgsepdriver.f pzgsepreq.f pdsepinfo.f ${zmatgen})

add_executable(xsnep psnepdriver.f psnepinfo.f psnepfchk.f ${smatgen})
add_executable(xdnep pdnepdriver.f pdnepinfo.f pdnepfchk.f ${dmatgen})
add_executable(xcnep pcnepdriver.f pcnepinfo.f pcnepfchk.f ${cmatgen})
add_executable(xznep pznepdriver.f pznepinfo.f pznepfchk.f ${zmatgen})

add_executable(xcevc pcevcdriver.f pcevcinfo.f pcget22.f ${cmatgen})
add_executable(xzevc pzevcdriver.f pzevcinfo.f pzget22.f ${zmatgen})

add_executable(xssyevr pslasizesepr.f pslasizesyevr.f psseprdriver.f psseprreq.f psseprsubtst.f
pssepchk.f pssepqtq.f pslatms.f psseprtst.f pssepinfo.f pslagsy.f pslasizesep.f ${smatgen})
add_executable(xdsyevr  pdlasizesepr.f pdlasizesyevr.f pdseprdriver.f pdseprreq.f pdseprsubtst.f
pdsepchk.f pdsepqtq.f pdlatms.f pdseprtst.f pdsepinfo.f pdlagsy.f pdlasizesep.f ${dmatgen}) 
add_executable(xcheevr pclasizesepr.f pclasizeheevr.f pcseprdriver.f pcseprreq.f pcseprsubtst.f
pcsepchk.f pcsepqtq.f pclatms.f pcseprtst.f pssepinfo.f pclagsy.f pclasizesep.f ${cmatgen})
add_executable(xzheevr  pzlasizesepr.f pzlasizeheevr.f pzseprdriver.f pzseprreq.f pzseprsubtst.f
pzsepchk.f pzsepqtq.f pzlatms.f pzseprtst.f pdsepinfo.f pzlagsy.f pzlasizesep.f ${zmatgen})

add_executable(xshseqr pshseqrdriver.f psmatgen2.f ${cmatgen})
add_executable(xdhseqr pdhseqrdriver.f pdmatgen2.f ${cmatgen})

target_link_libraries(xsbrd scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})
target_link_libraries(xdbrd scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})
target_link_libraries(xcbrd scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})
target_link_libraries(xzbrd scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})

target_link_libraries(xshrd scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})
target_link_libraries(xdhrd scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})
target_link_libraries(xchrd scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})
target_link_libraries(xzhrd scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})

target_link_libraries(xstrd scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})
target_link_libraries(xdtrd scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})
target_link_libraries(xctrd scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})
target_link_libraries(xztrd scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})

target_link_libraries(xssvd scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})
target_link_libraries(xdsvd scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})

target_link_libraries(xssep scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})
target_link_libraries(xdsep scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})
target_link_libraries(xcsep scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})
target_link_libraries(xzsep scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})

target_link_libraries(xsgsep scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})
target_link_libraries(xdgsep scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})
target_link_libraries(xcgsep scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})
target_link_libraries(xzgsep scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})

target_link_libraries(xsnep scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})
target_link_libraries(xdnep scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})
target_link_libraries(xcnep scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})
target_link_libraries(xznep scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})

target_link_libraries(xcevc scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})
target_link_libraries(xzevc scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})

target_link_libraries(xssyevr scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})
target_link_libraries(xdsyevr scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})
target_link_libraries(xcheevr scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})
target_link_libraries(xzheevr scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})

target_link_libraries(xshseqr scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})
target_link_libraries(xdhseqr scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})

if ("${CMAKE_Fortran_COMPILER_ID}" STREQUAL "GNU" AND CMAKE_Fortran_COMPILER_VERSION VERSION_GREATER_EQUAL 10)
    set( CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -std=legacy" )  # local to this directory
endif()

=== TESTING/LIN/CMakeLists.txt ===
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${SCALAPACK_BINARY_DIR}/TESTING)

set (smatgen psmatgen.f pmatgeninc.f)
set (dmatgen pdmatgen.f pmatgeninc.f)
set (cmatgen pcmatgen.f pmatgeninc.f)
set (zmatgen pzmatgen.f pmatgeninc.f)

set (slinchk pslaschk.f pslafchk.f)
set (dlinchk pdlaschk.f pdlafchk.f)
set (clinchk pclaschk.f pclafchk.f)
set (zlinchk pzlaschk.f pzlafchk.f)

add_executable(xslu psludriver.f psluinfo.f psgetrrv.f ${smatgen} ${slinchk})
add_executable(xdlu pdludriver.f pdluinfo.f pdgetrrv.f ${dmatgen} ${dlinchk})
add_executable(xclu pcludriver.f pcluinfo.f pcgetrrv.f ${cmatgen} ${clinchk})
add_executable(xzlu pzludriver.f pzluinfo.f pzgetrrv.f ${zmatgen} ${zlinchk})

add_executable(xsdblu psdbdriver.f psdbinfo.f psdblaschk.f psdbmv1.f psbmatgen.f ${smatgen})
add_executable(xddblu pddbdriver.f pddbinfo.f pddblaschk.f pddbmv1.f pdbmatgen.f ${dmatgen})
add_executable(xcdblu pcdbdriver.f pcdbinfo.f pcdblaschk.f pcdbmv1.f pcbmatgen.f ${cmatgen})
add_executable(xzdblu pzdbdriver.f pzdbinfo.f pzdblaschk.f pzdbmv1.f pzbmatgen.f ${zmatgen})

add_executable(xsdtlu psdtdriver.f psdtinfo.f psdtlaschk.f psdbmv1.f psbmatgen.f ${smatgen})
add_executable(xddtlu pddtdriver.f pddtinfo.f pddtlaschk.f pddbmv1.f pdbmatgen.f ${dmatgen})
add_executable(xcdtlu pcdtdriver.f pcdtinfo.f pcdtlaschk.f pcdbmv1.f pcbmatgen.f ${cmatgen})
add_executable(xzdtlu pzdtdriver.f pzdtinfo.f pzdtlaschk.f pzdbmv1.f pzbmatgen.f ${zmatgen})

add_executable(xsgblu psgbdriver.f psgbinfo.f psdblaschk.f psgbmv1.f psbmatgen.f ${smatgen})
add_executable(xdgblu pdgbdriver.f pdgbinfo.f pddblaschk.f pdgbmv1.f pdbmatgen.f ${dmatgen})
add_executable(xcgblu pcgbdriver.f pcgbinfo.f pcdblaschk.f pcgbmv1.f pcbmatgen.f ${cmatgen})
add_executable(xzgblu pzgbdriver.f pzgbinfo.f pzdblaschk.f pzgbmv1.f pzbmatgen.f ${zmatgen})

add_executable(xsllt pslltdriver.f pslltinfo.f pspotrrv.f ${smatgen} ${slinchk})
add_executable(xdllt pdlltdriver.f pdlltinfo.f pdpotrrv.f ${dmatgen} ${dlinchk})
add_executable(xcllt pclltdriver.f pclltinfo.f pcpotrrv.f ${cmatgen} ${clinchk})
add_executable(xzllt pzlltdriver.f pzlltinfo.f pzpotrrv.f ${zmatgen} ${zlinchk})

add_executable(xspbllt pspbdriver.f pspbinfo.f pspblaschk.f pspbmv1.f psbmatgen.f ${smatgen})
add_executable(xdpbllt pdpbdriver.f pdpbinfo.f pdpblaschk.f pdpbmv1.f pdbmatgen.f ${dmatgen})
add_executable(xcpbllt pcpbdriver.f pcpbinfo.f pcpblaschk.f pcpbmv1.f pcbmatgen.f ${cmatgen})
add_executable(xzpbllt pzpbdriver.f pzpbinfo.f pzpblaschk.f pzpbmv1.f pzbmatgen.f ${zmatgen})

add_executable(xsptllt psptdriver.f psptinfo.f psptlaschk.f pspbmv1.f psbmatgen.f ${smatgen})
add_executable(xdptllt pdptdriver.f pdptinfo.f pdptlaschk.f pdpbmv1.f pdbmatgen.f ${dmatgen})
add_executable(xcptllt pcptdriver.f pcptinfo.f pcptlaschk.f pcpbmv1.f pcbmatgen.f ${cmatgen})
add_executable(xzptllt pzptdriver.f pzptinfo.f pzptlaschk.f pzpbmv1.f pzbmatgen.f ${zmatgen})

add_executable(xsinv psinvdriver.f psinvinfo.f psinvchk.f ${smatgen})
add_executable(xdinv pdinvdriver.f pdinvinfo.f pdinvchk.f ${dmatgen})
add_executable(xcinv pcinvdriver.f pcinvinfo.f pcinvchk.f ${cmatgen})
add_executable(xzinv pzinvdriver.f pzinvinfo.f pzinvchk.f ${zmatgen})

add_executable(xsqr psqrdriver.f psqrinfo.f psgeqrrv.f psgeqlrv.f psgelqrv.f psgerqrv.f pstzrzrv.f pslafchk.f ${smatgen})
add_executable(xdqr pdqrdriver.f pdqrinfo.f pdgeqrrv.f pdgeqlrv.f pdgelqrv.f pdgerqrv.f pdtzrzrv.f pdlafchk.f ${dmatgen})
add_executable(xcqr pcqrdriver.f pcqrinfo.f pcgeqrrv.f pcgeqlrv.f pcgelqrv.f pcgerqrv.f pctzrzrv.f pclafchk.f ${cmatgen})
add_executable(xzqr pzqrdriver.f pzqrinfo.f pzgeqrrv.f pzgeqlrv.f pzgelqrv.f pzgerqrv.f pztzrzrv.f pzlafchk.f ${zmatgen})

add_executable(xsls pslsdriver.f pslsinfo.f psqrt13.f psqrt14.f psqrt16.f psqrt17.f ${smatgen})
add_executable(xdls pdlsdriver.f pdlsinfo.f pdqrt13.f pdqrt14.f pdqrt16.f pdqrt17.f ${dmatgen})
add_executable(xcls pclsdriver.f pclsinfo.f pcqrt13.f pcqrt14.f pcqrt16.f pcqrt17.f ${cmatgen})
add_executable(xzls pzlsdriver.f pzlsinfo.f pzqrt13.f pzqrt14.f pzqrt16.f pzqrt17.f ${zmatgen})


target_link_libraries(xslu scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})
target_link_libraries(xdlu scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})
target_link_libraries(xclu scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})
target_link_libraries(xzlu scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})

target_link_libraries(xsdblu scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})
target_link_libraries(xddblu scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})
target_link_libraries(xcdblu scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})
target_link_libraries(xzdblu scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})

target_link_libraries(xsdtlu scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})
target_link_libraries(xddtlu scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})
target_link_libraries(xcdtlu scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})
target_link_libraries(xzdtlu scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})

target_link_libraries(xsgblu scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})
target_link_libraries(xdgblu scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})
target_link_libraries(xcgblu scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})
target_link_libraries(xzgblu scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})

target_link_libraries(xsllt scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})
target_link_libraries(xdllt scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})
target_link_libraries(xcllt scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})
target_link_libraries(xzllt scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})

target_link_libraries(xspbllt scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})
target_link_libraries(xdpbllt scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})
target_link_libraries(xcpbllt scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})
target_link_libraries(xzpbllt scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})

target_link_libraries(xsptllt scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})
target_link_libraries(xdptllt scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})
target_link_libraries(xcptllt scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})
target_link_libraries(xzptllt scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})

target_link_libraries(xsinv scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})
target_link_libraries(xdinv scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})
target_link_libraries(xcinv scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})
target_link_libraries(xzinv scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})

target_link_libraries(xsqr scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})
target_link_libraries(xdqr scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})
target_link_libraries(xcqr scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})
target_link_libraries(xzqr scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})

target_link_libraries(xsls scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})
target_link_libraries(xdls scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})
target_link_libraries(xcls scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})
target_link_libraries(xzls scalapack ${LAPACK_LIBRARIES} ${BLAS_LIBRARIES})

if ("${CMAKE_Fortran_COMPILER_ID}" STREQUAL "GNU" AND CMAKE_Fortran_COMPILER_VERSION VERSION_GREATER_EQUAL 10)
    set( CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -std=legacy" )  # local to this directory
endif()

=== PBLAS/SRC/PTOOLS/Makefile ===
############################################################################
#
#  Program:         PBLAS -- (version 2.0)
#
#  Module:          Makefile
#
#  Purpose:         PTOOLS makefile
#
#  Creation date:   April 1, 1998
#
#  Modified:        February 15, 2000
#
#  Send bug reports, comments or suggestions to scalapack@cs.utk.edu
#
############################################################################

include ../../../SLmake.inc

############################################################################
#
#  This is the makefile to create a library for the PBLAS F77 tools.
#  The files are grouped as follows:
#
#     ALLTOOLS -- Auxiliary routines for Level 1, 2 and 3 PBLAS
#
#       STOOLS -- Single precision real PBLAS Level F77 tools routines
#       CTOOLS -- Single precision complex PBLAS Level F77 tools routines
#       DTOOLS -- Double precision real PBLAS Level F77 tools routines
#       ZTOOLS -- Double precision complex PBLAS Level F77 tools routines
#
#  The library can be set up to include routines for any combination
#  of the four precisions.  First, modify the ../../../SLmake.inc file
#  definitions to match your compiler and the options to be used.
#  Then to create or add to the library, enter make followed by one or
#  more of the precisions desired.  Some examples:
#       make single
#       make single complex
#       make single double complex complex16
#  Alternatively, the command
#       make
#  without any arguments creates a library of all four precisions.
#
#  To remove the object files after the library is created, enter
#       make clean
#
############################################################################

all: single double complex complex16

#---------------------------------------------------------------------------
#  The following line defines auxiliary routines needed by the PBLAS tools
#---------------------------------------------------------------------------

ALLCTOOLS = \
    PB_CGatherV.o    PB_CInV.o        PB_CInV2.o       PB_CInOutV.o     \
    PB_CInOutV2.o    PB_COutV.o       PB_CScatterV.o   PB_CVMinit.o     \
    PB_CVMloc.o      PB_CVMnpq.o      PB_CVMpack.o     PB_CVMswp.o      \
    PB_CVMupdate.o   PB_CVMcontig.o   PB_Cabort.o      PB_Cainfog2l.o   \
    PB_Cbinfo.o      PB_Cchkmat.o     PB_Cchkvec.o     PB_Cconjg.o      \
    PB_Cgetbuf.o     PB_Cinfog2l.o    PB_Citypeset.o   PB_Cgcd.o        \
    PB_Clcm.o        PB_Cmalloc.o     PB_Cnumroc.o     PB_Cg2lrem.o     \
    PB_Cindxg2p.o    PB_Cnnxtroc.o    PB_Cnpreroc.o    PB_CpswapNN.o    \
    PB_CpswapND.o    PB_Cpdot11.o     PB_CpdotNN.o     PB_CpdotND.o     \
    PB_CpaxpbyNN.o   PB_CpaxpbyND.o   PB_CpaxpbyDN.o   PB_Cpaxpby.o     \
    PB_CpgemmBC.o    PB_CpgemmAC.o    PB_CpgemmAB.o    PB_Cplaprnt.o    \
    PB_Cplapad.o     PB_Cplapd2.o     PB_Cplascal.o    PB_Cplasca2.o    \
    PB_Cplacnjg.o    PB_Cpsym.o       PB_CpsymmAB.o    PB_CpsymmBC.o    \
    PB_Cpsyr.o       PB_CpsyrkA.o     PB_CpsyrkAC.o    PB_Cpsyr2.o      \
    PB_Cpsyr2kA.o    PB_Cpsyr2kAC.o   PB_Cptrm.o       PB_Cpgeadd.o     \
    PB_Cptradd.o     PB_Cptran.o      PB_CptrmmAB.o    PB_CptrmmB.o     \
    PB_Cptrsm.o      PB_CptrsmAB.o    PB_CptrsmAB0.o   PB_CptrsmAB1.o   \
    PB_CptrsmB.o     PB_Cptrsv.o      PB_Ctop.o        PB_Ctzahemv.o    \
    PB_Ctzasymv.o    PB_Ctzatrmv.o    PB_Ctzhemm.o     PB_Ctzhemv.o     \
    PB_Ctzher.o      PB_Ctzherk.o     PB_Ctzher2.o     PB_Ctzher2k.o    \
    PB_Ctzsymm.o     PB_Ctzsymv.o     PB_Ctzsyr.o      PB_Ctzsyrk.o     \
    PB_Ctzsyr2.o     PB_Ctzsyr2k.o    PB_Ctztrmm.o     PB_Ctztrmv.o     \
    PB_Cwarn.o       PB_freebuf_.o    PB_topget_.o     PB_topset_.o     \
    PB_Cdescset.o    PB_Cdescribe.o   PB_CargFtoC.o    PB_Cfirstnb.o    \
    PB_Clastnb.o     PB_Cspan.o

#---------------------------------------------------------------------------

ALLTOOLS = $(ALLCTOOLS)

#---------------------------------------------------------------------------
#  The C PBLAS tools
#---------------------------------------------------------------------------

SCTOOLS = PB_Cstypeset.o

DCTOOLS = PB_Cdtypeset.o

CCTOOLS = PB_Cctypeset.o

ZCTOOLS = PB_Cztypeset.o

#---------------------------------------------------------------------------

STOOLS = $(SCTOOLS)
CTOOLS = $(CCTOOLS) $(SCTOOLS)
DTOOLS = $(DCTOOLS)
ZTOOLS = $(ZCTOOLS) $(DCTOOLS)

#---------------------------------------------------------------------------

SPTOOLS = $(ALLTOOLS) $(STOOLS)
CPTOOLS = $(ALLTOOLS) $(CTOOLS)
DPTOOLS = $(ALLTOOLS) $(DTOOLS)
ZPTOOLS = $(ALLTOOLS) $(ZTOOLS)

single: $(SPTOOLS)
	$(ARCH) $(ARCHFLAGS) ../../../$(SCALAPACKLIB) $(SPTOOLS)
	$(RANLIB) ../../../$(SCALAPACKLIB)

complex: $(CPTOOLS)
	$(ARCH) $(ARCHFLAGS) ../../../$(SCALAPACKLIB) $(CPTOOLS)
	$(RANLIB) ../../../$(SCALAPACKLIB)

double: $(DPTOOLS)
	$(ARCH) $(ARCHFLAGS) ../../../$(SCALAPACKLIB) $(DPTOOLS)
	$(RANLIB) ../../../$(SCALAPACKLIB)

complex16: $(ZPTOOLS)
	$(ARCH) $(ARCHFLAGS) ../../../$(SCALAPACKLIB) $(ZPTOOLS)
	$(RANLIB) ../../../$(SCALAPACKLIB)

clean:
	rm -f *.o

.f.o : ; $(FC) -c $(FCFLAGS) $*.f
.c.o : ; $(CC) -c $(CDEFS) $(CCFLAGS) $*.c

=== debian/changelog ===
scalapack (2.2.1-5) unstable; urgency=medium

  * Team upload.
  * treat implicit-function-declaration as no-error on powerpc
    (DEB_BUILD_MAINT_OPTIONS qa is ignored on powerpc, see Bug#1082275)

 -- Drew Parsons <dparsons@debian.org>  Thu, 19 Sep 2024 18:05:04 +0200

scalapack (2.2.1-4exp4) experimental; urgency=medium

  * Team upload.
  * debian/rules: fix definition of MPI_SUPPORTED

 -- Drew Parsons <dparsons@debian.org>  Thu, 19 Sep 2024 02:42:35 +0200

scalapack (2.2.1-4exp3) experimental; urgency=medium

  * Team upload.
  * debian/rules: fix definition of SCALAPACK_SOVERSION
    (from dpkg's DEB_VERSION_UPSTREAM)

 -- Drew Parsons <dparsons@debian.org>  Thu, 19 Sep 2024 01:50:45 +0200

scalapack (2.2.1-4exp2) experimental; urgency=medium

  * Team upload.
  * provide a 64-bit build only where libblas64-dev is supported
    i.e. where DEB_HOST_ARCH_BITS=64
    [!armel !armhf !i386 !hppa !hurd-i386 !m68k !powerpc !sh4 !x32]
  * debian/rules: set DEB_BUILD_MAINT_OPTIONS = qa=-bug-implicit-func
    since BLACS source does not use headers declaring all functions
  * don't build or run tests for openmpi on 32-bit architectures.
    openmpi 4 is still built for these arches, but mpi-default-dev
    already marks them as not supporting openmpi. Closes: #1068322.
  * Build-Depends: pkgconf not pkg-config
  * Standards-Version: 4.7.0

 -- Drew Parsons <dparsons@debian.org>  Wed, 18 Sep 2024 21:32:04 +0200

scalapack (2.2.1-4exp1) experimental; urgency=medium

  * Team upload.
  * provide 64-bit integer support in libscalapack64* packages
    built against libblas64.so. Closes: #961186.
    - update debian patch sharedlibs-soname.patch to append
      LIBNAME_SUFFIX to library name (libscalapack64-{mpi}.so)
    - debian patch test_64bit.patch defines preprocessor variable
      TEST_INT64 to set 64-bit integers in tests (see README)
      Needs -cpp fortran flag to enable preprocessing on *.f.
  * configure with BLA_VENDOR=Generic to ensure FindLAPACK builds
    against the generic implementation of BLAS/LAPACK
  * use dh_auto_test --max-parallel to restrict the number of test
    jobs run at the same time according to the total number of
    processes available at build time (each test uses 4 processes)
    Build-Depends: bc for shell arithmetic (default shell is dash)
  * apply debian patch install_libdir_multiarch.patch first
  * skip tests known to time out or fail
    - complex evr tests often time out, and are significantly slower
      than other tests even if they do pass. Always skip them both
      (x[cz]heevr)
    - xssep, xsgsep and xssyevr are known to fail in the 64-bit build
      (see README). xdsyevr passes but is slow, skip it in 64-bit tests
    -  xsllt times out with OpenMPI, xdllt, xdlu time out with
       MPICH. but both mpi's pass in the 64-bit builds. Weird. Skip
       them according to mpi flavor.
    - BLACS tests (xCbtest, xFbtest) do not work with the 64-bit build

 -- Drew Parsons <dparsons@debian.org>  Mon, 30 Oct 2023 22:38:39 +0100

scalapack (2.2.1-3) unstable; urgency=medium

  * Team upload.

  [ Debian Janitor ]
  * Trim trailing whitespace.
  * Use secure URI in Homepage field.
  * Update renamed lintian tag names in lintian overrides.
  * Set upstream metadata fields: Repository-Browse.
  * Fix day-of-week for changelog entry 1.8.0-7.
  * Avoid explicitly specifying -Wl,--as-needed linker flag.

  [ Drew Parsons ]
  * debian patch install_libdir_multiarch.patch installs libraries,
    cmake and pkgconfig files into multiarch destinations
    (CMAKE_INSTALL_LIBDIR from GNUInstallDirs). Closes: #1051986.
  * extend debian patch sharedlibs-soname.patch to add MPI_FLAVOR
    suffix to installed pkgconfig files and cmake install dirs.
    Simplifies package install scripts (executable scripts no longer
    needed).
  * debian/rules: set LD_LIBRARY_PATH to new libraries only when
    running tests
  * Standards-Version: 4.6.2

 -- Drew Parsons <dparsons@debian.org>  Thu, 26 Oct 2023 00:08:06 +0200

scalapack (2.2.1-2) unstable; urgency=medium

  * Team upload
  * Fix FTBFS against cmake 3.24.
    The CMakeFiles/Export/ subdirectory structure has changed between CMake 3.23
    and 3.24. We are relying on this directory for installing
    scalapack-targets-none.cmake, which differs between OpenMPI and MPICH.
    Adapt libscalapack-{openmpi,mpich}-dev.install accordingly.
    See https://gitlab.kitware.com/cmake/cmake/-/issues/23883
    (Closes: #1020170)
  * Honour DEB_BUILD_OPTIONS=nocheck
  * Add missing files to clean rule

 -- Sébastien Villemot <sebastien@debian.org>  Tue, 11 Oct 2022 18:05:29 +0200

scalapack (2.2.1-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
    - applies debian patch project_version.patch
  * use DEB_VERSION_UPSTREAM from /usr/share/dpkg/pkg-info.mk
    in build scripts
  * replace DEB_HOST_MULTIARCH with CMAKE_LIBRARY_ARCHITECTURE in all
    installed cmake files
  * specify mpiexec for MPI flavor when configuring the build

 -- Drew Parsons <dparsons@debian.org>  Sun, 06 Mar 2022 11:46:29 +0100

scalapack (2.2.0-1exp1) experimental; urgency=medium

  * Team upload.
  * New upstream major release (soname bump to 2.2).
    (technically a minor version update, but the debian soname tracks
     the major.minor version)
  * Standards-Version: 4.6.0
  * debian patch restore_mpifort_revert_PR39.patch reverts upstream
    PR#39 to restore assignment of MPI_Fortran_COMPILER as
    CMAKE_Fortran_COMPILER. Otherwise tests fail to link libmpi.so
    cf. https://github.com/Reference-ScaLAPACK/scalapack/issues/47
  * split debian patch project_version.patch out of
    sharedlibs-soname.patch to set VERSION via the cmake project command
  * clean generated files after dh_clean
  * build BLACS and PBLAS tests (SCALAPACK_BUILD_TESTING)

 -- Drew Parsons <dparsons@debian.org>  Thu, 17 Feb 2022 10:37:33 +0100

=== debian/control ===
Source: scalapack
Section: devel
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Muammar El Khatib <muammar@debian.org>
Standards-Version: 4.7.0
Build-Depends: debhelper-compat (= 13),
 cmake,
 mpi-default-dev,
 mpi-default-bin,
 libopenmpi-dev [!armel !armhf !i386 !hurd-i386 !hppa !m68k !powerpc !sh4 !x32],
 mpich, libmpich-dev,
 gfortran,
 libblas-dev | libopenblas-dev | libatlas-base-dev | libblas.so,
 liblapack-dev | libopenblas-dev | libatlas-base-dev | liblapack.so,
 libblas64-dev [!armel !armhf !i386 !hppa !hurd-i386 !m68k !powerpc !sh4 !x32]
   | libopenblas64-dev [!armel !armhf !i386 !hppa !hurd-i386 !m68k !powerpc !sh4 !x32]
   | libatlas64-base-dev [!armel !armhf !i386 !hppa !hurd-i386 !m68k !powerpc !sh4 !x32]
   | libblas64.so [!armel !armhf !i386 !hppa !hurd-i386 !m68k !powerpc !sh4 !x32],
 liblapack64-dev [!armel !armhf !i386 !hppa !hurd-i386 !m68k !powerpc !sh4 !x32]
   | libopenblas64-dev [!armel !armhf !i386 !hppa !hurd-i386 !m68k !powerpc !sh4 !x32]
   | libatlas64-base-dev [!armel !armhf !i386 !hppa !hurd-i386 !m68k !powerpc !sh4 !x32]
   | liblapack64.so [!armel !armhf !i386 !hppa !hurd-i386 !m68k !powerpc !sh4 !x32],
 pkgconf,
 bc,
 chrpath
Homepage: https://www.netlib.org/scalapack/
Vcs-Git: https://salsa.debian.org/science-team/scalapack.git
Vcs-Browser: https://salsa.debian.org/science-team/scalapack

Package: libscalapack-openmpi2.2
Section: libs
Architecture: alpha amd64 arm64 hurd-amd64 ia64 kfreebsd-amd64 loong64 mips64el ppc64 ppc64el riscv64 s390x sparc64
Multi-Arch: same
Depends: mpi-default-bin, ${shlibs:Depends}, ${misc:Depends}
Conflicts: scalapack2-mpich
Breaks: libscalapack-mpi1 (<< 1.8.0-9.1)
Replaces: scalapack1-mpich, libscalapack-mpi1 (<< 1.8.0-9.1)
Suggests: scalapack-doc
Description: Scalable Linear Algebra Package - Shared libs for OpenMPI
 ScaLAPACK is the parallel version of LAPACK used on clusters.
 .
 There are packages for the shared libraries (this one), for the
 static libraries and the development files and for test programs.
 .
 Also included:
   - PBLAS, Parallel Basic Linear Algebra Subprograms
   - BLACS, Basic Linear Algebra Communication Subprograms
 .
 This package supports the OpenMPI implementation of MPI.

Package: libscalapack-mpich2.2
Section: libs
Architecture: any
Multi-Arch: same
Depends: mpi-default-bin, ${shlibs:Depends}, ${misc:Depends}
Conflicts: scalapack2-mpich
Breaks: libscalapack-mpi1 (<< 1.8.0-9.1)
Replaces: scalapack1-mpich, libscalapack-mpi1 (<< 1.8.0-9.1)
Suggests: scalapack-doc
Description: Scalable Linear Algebra Package - Shared libs for MPICH
 ScaLAPACK is the parallel version of LAPACK used on clusters.
 .
 There are packages for the shared libraries (this one), for the
 static libraries and the development files and for test programs.
 .
 Also included:
   - PBLAS, Parallel Basic Linear Algebra Subprograms
   - BLACS, Basic Linear Algebra Communication Subprograms
 .
 This package supports the MPICH implementation of MPI.

Package: libscalapack-mpi-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${scalapack-mpi-dev}, mpi-default-dev, ${misc:Depends}
Replaces: libblacs-mpi-dev
Provides: libblacs-mpi-dev
Suggests: scalapack-doc
Description: Scalable Linear Algebra Package - Dev files for MPI
 ScaLAPACK is the parallel version of LAPACK used on clusters.
 .
 There are packages for the shared libraries, for the static libraries and
 the development files (this one) and for test programs.
 .
 Also included:
    - PBLAS, Parallel Basic Linear Algebra Subprograms
    - BLACS, Basic Linear Algebra Communication Subprograms
 .
 This is a dummy package which depends on the scalapack development package
 supporting the default implementation of MPI on this architecture.

Package: libscalapack-mpich-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libscalapack-mpich2.2 (= ${binary:Version}), ${misc:Depends}
Breaks: libscalapack-mpi-dev (<< 2.0.2-1)
Replaces: libblacs-mpi-dev
Provides: libblacs-mpi-dev
Suggests: scalapack-doc
Description: Scalable Linear Algebra Package - Dev files for MPICH
 ScaLAPACK is the parallel version of LAPACK used on clusters.
 .
 There are packages for the shared libraries, for the static libraries and
 the development files (this one) and for test programs.
 .
 Also included:
    - PBLAS, Parallel Basic Linear Algebra Subprograms
    - BLACS, Basic Linear Algebra Communication Subprograms
 Also included: PBLAS, Parallel Basic Linear Algebra Subprograms.
 .
 This package supports the MPICH implementation of MPI.

Package: libscalapack-openmpi-dev
Section: libdevel
Architecture: alpha amd64 arm64 hurd-amd64 ia64 kfreebsd-amd64 loong64 mips64el ppc64 ppc64el riscv64 s390x sparc64
Multi-Arch: same
Depends: libscalapack-openmpi2.2 (= ${binary:Version}), ${misc:Depends}
Breaks: libscalapack-mpi-dev (<< 2.0.2-1)
Replaces: libblacs-mpi-dev
Provides: libblacs-mpi-dev
Suggests: scalapack-doc
Description: Scalable Linear Algebra Package - Dev files for OpenMPI
 ScaLAPACK is the parallel version of LAPACK used on clusters.
 .
 There are packages for the shared libraries, for the static libraries and
 the development files (this one) and for test programs.
 .
 Also included:
    - PBLAS, Parallel Basic Linear Algebra Subprograms
    - BLACS, Basic Linear Algebra Communication Subprograms
 .
 This package supports the OpenMPI implementation of MPI.

Package: libscalapack64-openmpi2.2
Section: libs
Architecture: alpha amd64 arm64 hurd-amd64 ia64 kfreebsd-amd64 loong64 mips64el ppc64 ppc64el riscv64 s390x sparc64
Multi-Arch: same
Depends: mpi-default-bin, ${shlibs:Depends}, ${misc:Depends}
Suggests: scalapack-doc
Description: Scalable Linear Algebra Package - 64-bit Shared libs for OpenMPI
 ScaLAPACK is the parallel version of LAPACK used on clusters.
 .
 There are packages for the shared libraries (this one), for the
 static libraries and the development files and for test programs.
 .
 Also included:
   - PBLAS, Parallel Basic Linear Algebra Subprograms
   - BLACS, Basic Linear Algebra Communication Subprograms
 .
 This package provides 64 bit integer support and uses the OpenMPI
 implementation of MPI.

Package: libscalapack64-mpich2.2
Section: libs
Architecture: any
Multi-Arch: same
Depends: mpi-default-bin, ${shlibs:Depends}, ${misc:Depends}
Conflicts: scalapack2-mpich
Breaks: libscalapack-mpi1 (<< 1.8.0-9.1)
Replaces: scalapack1-mpich, libscalapack-mpi1 (<< 1.8.0-9.1)
Suggests: scalapack-doc
Description: Scalable Linear Algebra Package - 64-bit Shared libs for MPICH
 ScaLAPACK is the parallel version of LAPACK used on clusters.
 .
 There are packages for the shared libraries (this one), for the
 static libraries and the development files and for test programs.
 .
 Also included:
   - PBLAS, Parallel Basic Linear Algebra Subprograms
   - BLACS, Basic Linear Algebra Communication Subprograms
 .
 This package provides 64 bit integer support and uses the MPICH
 implementation of MPI.

Package: libscalapack64-mpi-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${scalapack-mpi-dev}, mpi-default-dev, ${misc:Depends}
Replaces: libblacs-mpi-dev
Provides: libblacs-mpi-dev
Suggests: scalapack-doc
Description: Scalable Linear Algebra Package - 64-bit Dev files for MPI
 ScaLAPACK is the parallel version of LAPACK used on clusters.
 .
 There are packages for the shared libraries, for the static libraries and
 the development files (this one) and for test programs.
 .
 Also included:
    - PBLAS, Parallel Basic Linear Algebra Subprograms
    - BLACS, Basic Linear Algebra Communication Subprograms
 .
 This is a dummy package which depends on the scalapack development package
 supporting the default implementation of MPI on this architecture and
 providing 64 bit integer support.

Package: libscalapack64-mpich-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libscalapack64-mpich2.2 (= ${binary:Version}), ${misc:Depends}
Suggests: scalapack-doc
Description: Scalable Linear Algebra Package - 64-bit Dev files for MPICH
 ScaLAPACK is the parallel version of LAPACK used on clusters.
 .
 There are packages for the shared libraries, for the static libraries and
 the development files (this one) and for test programs.
 .
 Also included:
    - PBLAS, Parallel Basic Linear Algebra Subprograms
    - BLACS, Basic Linear Algebra Communication Subprograms
 Also included: PBLAS, Parallel Basic Linear Algebra Subprograms.
 .
 This package provides 64 bit integer support and uses the MPICH
 implementation of MPI.

Package: libscalapack64-openmpi-dev
Section: libdevel
Architecture: alpha amd64 arm64 hurd-amd64 ia64 kfreebsd-amd64 loong64 mips64el ppc64 ppc64el riscv64 s390x sparc64
Multi-Arch: same
Depends: libscalapack64-openmpi2.2 (= ${binary:Version}), ${misc:Depends}
Suggests: scalapack-doc
Description: Scalable Linear Algebra Package - 64-bit Dev files for OpenMPI
 ScaLAPACK is the parallel version of LAPACK used on clusters.
 .
 There are packages for the shared libraries, for the static libraries and
 the development files (this one) and for test programs.
 .
 Also included:
    - PBLAS, Parallel Basic Linear Algebra Subprograms
    - BLACS, Basic Linear Algebra Communication Subprograms
 .
 This package provides 64 bit integer support and uses the OpenMPI
 implementation of MPI.

Package: scalapack-mpi-test
Section: math
Architecture: any
Multi-Arch: same
Depends: scalapack-test-common, ${shlibs:Depends}, ${misc:Depends}
Recommends: cmake
Conflicts: scalapack-mpich-test
Replaces: scalapack-mpich-test, blacs-mpi-test
Provides: scalapack-mpich-test, blacs-mpi-test
Suggests: scalapack-doc
Description: Scalable Linear Algebra Package - Test files for MPI
 ScaLAPACK is the parallel version of LAPACK used on clusters.
 .
 Also included:
    - PBLAS, Parallel Basic Linear Algebra Subprograms
    - BLACS, Basic Linear Algebra Communication Subprograms
 .
 This package contains ScaLAPACK, PBLAS and BLACS test programs.

Package: scalapack-test-common
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Replaces: blacs-test-common
Provides: blacs-test-common
Suggests: scalapack-mpi-test
Description: Test data for ScaLAPACK testers
 ScaLAPACK is the parallel version of LAPACK used on clusters.
 .
 Also included:
    - PBLAS, Parallel Basic Linear Algebra Subprograms
    - BLACS, Basic Linear Algebra Communication Subprograms
 .
 This package contains data files used by test programs.

=== debian/rules ===
#! /usr/bin/make -f

include /usr/share/dpkg/architecture.mk

# eventually add -O3 -march=native -mtune=native
export DEB_BUILD_MAINT_OPTIONS = qa=-bug-implicit-func
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
export DEB_CXXFLAGS_MAINT_APPEND  = -Wall -pedantic
export DEB_FFLAGS_MAINT_APPEND  = -std=legacy
export DEB_LDFLAGS_MAINT_STRIP = -Wl,-Bsymbolic-functions

# DEB_BUILD_MAINT_OPTIONS qa is ignored on powerpc, Bug#1082275
ifeq ($(DEB_HOST_ARCH),powerpc)
  DEB_CFLAGS_MAINT_APPEND += -Wno-error=implicit-function-declaration
endif

ifneq (,$(wildcard /usr/share/mpi-default-dev/debian_defaults))
include /usr/share/mpi-default-dev/debian_defaults
endif
DEFAULT_MPI=$(ARCH_DEFAULT_MPI_IMPL)

empty :=
space := $(empty)$(empty)

export MPI_SUPPORTED=
ifneq (,$(findstring $(space)$(DEB_HOST_ARCH)$(space), $(space)$(OPENMPI_AVAILABLE_ARCHITECTURES)$(space)))
  MPI_SUPPORTED += openmpi
endif
ifneq (,$(findstring $(space)$(DEB_HOST_ARCH)$(space), $(space)$(MPICH_AVAILABLE_ARCHITECTURES)$(space)))
  MPI_SUPPORTED += mpich
endif

include /usr/share/dpkg/pkg-info.mk
SCALAPACK_UPSTREAM_VERSION=$(DEB_VERSION_UPSTREAM)
SCALAPACK_X_Y_VERSION=$(shell echo $(SCALAPACK_UPSTREAM_VERSION) | sed "s/^\(.*\)\.\([^.]*\)$$/\1/")
export SCALAPACK_SOVERSION=$(SCALAPACK_X_Y_VERSION)

# 64-bit build is not supported on all arches
ifeq (64,$(DEB_HOST_ARCH_BITS))
  BIT_BUILDS = 32 64
else
  BIT_BUILDS = 32
  export DH_OPTIONS += \
	-Nlibscalapack64-mpi-dev \
	-Nlibscalapack64-openmpi-dev -Nlibscalapack64-openmpi${SCALAPACK_SOVERSION} \
	-Nlibscalapack64-mpich-dev -Nlibscalapack64-mpich${SCALAPACK_SOVERSION}
endif

%:
	dh $@ --buildsystem=cmake

export OMPI_MCA_plm_rsh_agent=/bin/false                #workaround to start MPI-applications in chroot

export NUMJOBS=1
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
export NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
endif

extra_flags += \
 -DBUILD_SHARED_LIBS=ON \
 -DSCALAPACK_BUILD_TESTING=ON \
 -DBLA_VENDOR=Generic

# BLA_SIZEOF_INTEGER is a cmake FindLAPACK variable to find 32- or 64-bit interfaces
extra_64bit_flags += \
	-DLIBNAME_SUFFIX=64 \
	-DBLA_SIZEOF_INTEGER=8

common_Fortran_FLAGS=-cpp
Fortran_FLAGS_64=-fdefault-integer-8 -DTEST_INT64=1
C_FLAGS_64=-DInt=long

execute_after_dh_clean:
	cd BLACS/INSTALL; rm -rf xintface Makefile CMakeCache.txt cmake_install.cmake CMakeFiles
	cd PBLAS; rm -f TESTING/PB_Cabort.c TESTING/PB_Cwarn.c TIMING/PB_Cabort.c TIMING/PB_Cwarn.c
	rm -rf build*-openmpi build*-mpich

override_dh_auto_configure-indep:
override_dh_auto_build-indep:
override_dh_auto_install-indep:
override_dh_auto_test-indep:


override_dh_auto_configure-arch:
	for flavor in $(MPI_SUPPORTED); do \
	for BITS in $(BIT_BUILDS); do \
	  if [ $$BITS = 64 ]; then \
	    LIBNAME_SUFFIX=64; \
	    bit_flags='$(extra_64bit_flags)'; \
	    extra_C_FLAGS="$(C_FLAGS_64)"; \
	    extra_Fortran_FLAGS="$(Fortran_FLAGS_64)"; \
	  else \
	    LIBNAME_SUFFIX=; \
	    bit_flags=; \
	    extra_C_FLAGS=; \
	    extra_Fortran_FLAGS=; \
	  fi; \
	  echo "Configure for libscalapack$${LIBNAME_SUFFIX}-$${flavor}" ; \
	  dh_auto_configure --builddirectory=build$${LIBNAME_SUFFIX=}-$${flavor} -- $(extra_flags) $${bit_flags} \
	    "-DCMAKE_C_FLAGS=$(CFLAGS) $${extra_C_FLAGS}"  \
	    "-DCMAKE_Fortran_FLAGS=$(FFLAGS) $(common_Fortran_FLAGS) $${extra_Fortran_FLAGS}" \
	    -DMPI_C_COMPILER=mpicc.$$flavor -DMPI_Fortran_COMPILER=mpif90.$$flavor \
	    -DMPIEXEC_EXECUTABLE=/usr/bin/mpiexec.$$flavor -DMPI_FLAVOR=$$flavor ; \
	done; done

override_dh_auto_build-arch:
	for flavor in $(MPI_SUPPORTED); do \
	for BITS in $(BIT_BUILDS); do \
	  if [ $$BITS = 64 ]; then \
	    LIBNAME_SUFFIX=64; \
	  else \
	    LIBNAME_SUFFIX=; \
	  fi; \
	  echo "Building libscalapack$${LIBNAME_SUFFIX}-$${flavor}" ; \
	  dh_auto_build -O--parallel --builddirectory=build$${LIBNAME_SUFFIX}-$${flavor} ; \
	done; done

override_dh_auto_install-arch:
	echo "scalapack-mpi-dev=libscalapack-$(DEFAULT_MPI)-dev" > debian/libscalapack-mpi-dev.substvars
	for flavor in $(MPI_SUPPORTED); do \
	for BITS in $(BIT_BUILDS); do \
	  if [ $$BITS = 64 ]; then \
	    LIBNAME_SUFFIX=64; \
	  else \
	    LIBNAME_SUFFIX=; \
	  fi; \
	  echo "Installing scalapack$${LIBNAME_SUFFIX}-$${flavor}" ; \
	  dh_auto_install -O--parallel --builddirectory=build$${LIBNAME_SUFFIX}-$${flavor} ; \
	done; done

execute_after_dh_install-arch:
	dh_missing --list-missing
	# test executables contain RUNPATH. Remove it.
	chrpath -d debian/scalapack-mpi-test/usr/lib/$(DEB_HOST_MULTIARCH)/scalapack/*-tests/x*
	chrpath -d debian/scalapack-mpi-test/usr/lib/$(DEB_HOST_MULTIARCH)/scalapack/*-tests/PBLAS/*tst
	chrpath -d debian/scalapack-mpi-test/usr/lib/$(DEB_HOST_MULTIARCH)/scalapack/*-tests/PBLAS/TIMING/*tim


# add --max-parallel=1 to force test in sequential mode
# MPICH testsuite disabled as some tests fail -- why???

# Note: openmpi tests routinely (but unreproducibly) fail on some buildds,
# so don't let test failure halt the build on these arches (but let the tests run)
ARCH_TEST_IGNORE_FAILURE=mips64el

# On some other arches, openmpi3 tests never exit (don't even timeout),
# so skip their tests altogether until a workaround or fix is known.
ARCH_NO_OPENMPI_TEST_LIST=armel armhf i386 mipsel powerpc

# The hppa build does complete, but takes a full day to timeout on half the openmpi3 tests.
# That's too long, so add it to the no-test list
ARCH_NO_OPENMPI_TEST_LIST += hppa

# complex evr tests often time out, and are significantly slower than other tests
# even if they do pass. Skip them both.
SKIP_TESTS_COMMON=x[cz]heevr

# no current general 32-bit skips (see *MPI skips below)
SKIP_TESTS_32 ?=

# xssep, xsgsep and xssyevr are known to fail in the 64-bit build (see README)
# xdsyevr passes but is slow, skip it
SKIP_TESTS_64=xssep xsgsep xssyevr xdsyevr xCbtest xFbtest

# xsllt times out with OpenMPI, but xdllt, xdlu time out with MPICH.
# but all pass in the 64-bit builds. Weird.
SKIP_TESTS_OPENMPI=xsllt
SKIP_TESTS_MPICH=xdllt xdlu

override_dh_auto_test-arch:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	N_TEST_JOBS=`echo "x=$(NUMJOBS)/4; if (x>1) x else 1" | bc` ; \
	exclude_tests=""; \
	for t in $(SKIP_TESTS_COMMON); do \
	  if [ "x$${exclude_tests}" = "x" ]; then \
	    exclude_tests="$$t"; \
	  else \
	    exclude_tests="$${exclude_tests}|$$t"; \
	  fi; \
	done; \
	for BITS in $(BIT_BUILDS); do \
	  if [ $$BITS = 64 ]; then \
	    LIBNAME_SUFFIX=64; \
	    for t in $(SKIP_TESTS_64); do \
	        exclude_tests="$${exclude_tests}|$$t"; \
	    done; \
	  else \
	    LIBNAME_SUFFIX=; \
	    for t in $(SKIP_TESTS_32); do \
	        exclude_tests="$${exclude_tests}|$$t"; \
	    done; \
	  fi; \
	  for flavor in $(MPI_SUPPORTED); do \
	    echo "Running tests for libscalapack$${LIBNAME_SUFFIX}-$${flavor}" ; \
	    echo '************************************************'; \
	    echo "****** TESTING $$flavor BUILD ($${BITS}-bit integers)"; \
	    echo '************************************************'; \
	    for testDir in PBLAS/TESTING PBLAS/TIMING TESTING; do \
	      testfile=build$${LIBNAME_SUFFIX}-$${flavor}/$${testDir}/CTestTestfile.cmake; \
	      if ! grep -q separate_arguments.*ENV.*MPIEXEC_PREFLAGS $$testfile ; then \
	        sed '0,/add_test/ s/add_test/separate_arguments(MPIEXEC_PREFLAGS NATIVE_COMMAND $$ENV{MPIEXEC_PREFLAGS})\nadd_test/' -i $$testfile; \
	        sed 's/"$${MPIEXEC_PREFLAGS}"/$${MPIEXEC_PREFLAGS}/' -i $$testfile; \
	      fi; \
	    done; \
	    RUNTESTS=yes; \
	    if [ "$$flavor" = "openmpi" ]; then \
	      MPIEXEC_PREFLAGS="--allow-run-as-root --oversubscribe"; \
	      case " $(ARCH_NO_OPENMPI_TEST_LIST) " in \
	        *\ $(DEB_HOST_ARCH)\ *) RUNTESTS=no;; \
	      esac; \
	      for t in $(SKIP_TESTS_OPENMPI); do \
	          exclude_tests="$${exclude_tests}|$$t"; \
	      done; \
	    else \
	      unset MPIEXEC_PREFLAGS; \
	      for t in $(SKIP_TESTS_MPICH); do \
	          exclude_tests="$${exclude_tests}|$$t"; \
	      done; \
	    fi; \
